#!/usr/bin/env python
import sys
import MarkovLoc_Antie_Periph as POMDP

# Commented out by David Chen
#if len(sys.argv)>1 and sys.argv[1]:
#    Start,Dest = sys.argv[:2]
#else:
Start,Dest = 4,5

pomdp = POMDP.POMDP('Grid')

pomdp.grid = [
    '###########',
    '#.......###',
    '#.#.#.#.###',
    '#.......###',
    '#.#.#.#.###',
    '#.......#.#',
    '#.#.###.#.#',
    '#.........#',
    '#.#.#.#####',
    '#.....#####',
    '#.#.#.#####',
    '#.....#####',
    '#.#########',
    '#...#######',
    '#.#.#######',
    '#...#######',
    '###########',
    ]

pomdp.map_dir = 'Maps'
pomdp.map_image_file = 'MapDirection%s.png' % (pomdp.name)
pomdp.map_offsets = (25,0,300,440)

pomdp.locations = {
    1 : ( 1,1),  9 : ( 1,3), 17 : ( 1,5), 23 : (1,7),
    2 : ( 3,1), 10 : ( 3,3), 18 : ( 3,5), 24 : (3,7),
    3 : ( 5,1), 11 : ( 5,3), 19 : ( 5,5), 25 : (5,7), 27 : (5,9),
    4 : ( 7,1), 12 : ( 7,3), 20 : ( 7,5), 26 : (7,7), 28 : (7,9),
    5 : ( 9,1), 13 : ( 9,3), 21 : ( 9,5),
    6 : (11,1), 14 : (11,3), 22 : (11,5),
    7 : (13,1), 15 : (13,3),
    8 : (15,1), 16 : (15,3),
    }

pomdp.plat_row_offset = 4
pomdp.plat_col_offset = -1
pomdp.plat_directions = {'N':0, 'E':90, 'S':180, 'W':270}
pomdp.plat_orientations = {0:0, 90:1, 180:2, 270:3}

pomdp.NumPlaces=29
pomdp.NumPoses=4

pomdp.Gateways = {
    (1,1) : (9,1),
    (1,2) : (2,2),
    (2,1) : (10,1),
    (2,2) : (3,2),
    (3,1) : (11,1),
    (3,2) : (4,2),
    (4,1) : (12,1),
    (4,2) : (5,2),
    (5,1) : (13,1),
    (5,2) : (6,2),
    (6,1) : (14,1),
    (6,2) : (7,2),
    (7,1) : (15,1),
    (7,2) : (8,2),
    (8,1) : (16,1),
    (9,1) : (17,1),
    (9,2) : (10,2),
    (10,1) : (18,1),
    (10,2) : (11,2),
    (11,1) : (19,1),
    (11,2) : (12,2),
    (12,1) : (20,1),
    (12,2) : (13,2),
    (13,1) : (21,1),
    (13,2) : (14,2),
    (14,1) : (22,1),
    (15,2) : (16,2),
    (17,1) : (23,1),
    (17,2) : (18,2),
    (18,1) : (24,1),
    (18,2) : (19,2),
    (19,1) : (25,1),
    (20,1) : (26,1),
    (20,2) : (21,2),
    (21,2) : (22,2),
    (23,2) : (24,2),
    (24,2) : (25,2),
    (25,2) : (26,2),
    (26,1) : (28,1),
    (27,2) : (28,2),
    }

pomdp.PositionSet = {}

pomdp.PositionSet[0] = {
    1 : 10,
    2 : 26,
    3 : 5,
    4 : 23,
    5 : 15,
    6 : 19,
    7 : 13,
    }

pomdp.PositionSet[1] = {
    1 : 28,
    2 : 7,
    3 : 10,
    4 : 14,
    5 : 3,
    6 : 13,
    7 : 20,
    }

pomdp.PosSet = 0
pomdp.Positions = pomdp.PositionSet[pomdp.PosSet]

pomdp.PathSpecs = {
    '1+' : [(1,1),(9,1),(17,1),(23,1)],
    '2+' : [(2,1),(10,1),(18,1),(24,1)],
    '3+' : [(3,1),(11,1),(19,1),(25,1)],
    '4+' : [(4,1),(12,1),(20,1),(26,1),(28,1)],
    '5+' : [(5,1),(13,1),(21,1),],
    '6+' : [(6,1),(14,1),(22,1),],
    '7+' : [(7,1),(15,1),],
    '8+' : [(8,1),(16,1),],
    'A+' : [(1,2),(2,2),(3,2),(4,2),(5,2),(6,2),(7,2),(8,2)],
    'B+' : [(9,2),(10,2),(11,2),(12,2),(13,2),(14,2),],
    'B1+' : [(15,2),(16,2)],
    'C+' : [(17,2),(18,2),(19,2)],
    'C1+' : [(20,2),(21,2),(22,2),],
    'D+' : [(23,2),(24,2),(25,2),(26,2)],
    'E+' : [(27,2),(28,2)],
    }

pomdp.TextureLocs = {
    (1,1) : 'g',
    (1,2) : 't',
    (2,1) : 'r',
    (2,2) : 't',
    (3,1) : 'w',
    (3,2) : 't',
    (4,1) : 's',
    (4,2) : 't',
    (5,1) : 'c',
    (5,2) : 't',
    (6,1) : 'c',
    (6,2) : 't',
    (7,1) : 'c',
    (7,2) : 't',
    (8,1) : 'c',
    (9,1) : 'g',
    (9,2) : 'b',
    (10,1) : 'r',
    (10,2) : 'b',
    (11,1) : 'w',
    (11,2) : 'b',
    (12,1) : 's',
    (12,2) : 'b',
    (13,1) : 'c',
    (13,2) : 'b',
    (14,1) : 'c',
    (15,2) : 'c',
    (17,1) : 'g',
    (17,2) : 'c',
    (18,1) : 'r',
    (18,2) : 'c',
    (19,1) : 'w',
    (20,1) : 's',
    (20,2) : 'c',
    (21,2) : 'c',
    (23,2) : 'h',
    (24,2) : 'h',
    (25,2) : 'h',
    (26,1) : 's',
    (27,2) : 'c',
    }

pomdp.PictureLocs = {
    (1,1) : '6',
    (1,2) : '6',
    (2,1) : '6',
    (2,2) : '6',
    (3,1) : '6',
    (3,2) : '8',
    (4,1) : '8',
    (4,2) : '8',
    (5,1) : '8',
    (5,2) : '8',
    (6,1) : '8',
    (6,2) : '8',
    (7,1) : '8',
    (7,2) : '8',
    (8,1) : '8',
    (9,1) : '6',
    (9,2) : '6',
    (10,1) : '6',
    (10,2) : '6',
    (11,1) : '7',
    (11,2) : '7',
    (12,1) : '7',
    (12,2) : '8',
    (13,1) : '7',
    (13,2) : '8',
    (14,1) : '8',
    (15,2) : '8',
    (17,1) : '6',
    (17,2) : '6',
    (18,1) : '6',
    (18,2) : '6',
    (19,1) : '7',
    (20,1) : '7',
    (20,2) : '7',
    (21,2) : '7',
    (23,2) : '6',
    (24,2) : '6',
    (25,2) : '7',
    (26,1) : '7',
    (27,2) : '7',
    }

pomdp.ObjectLocs = {
    3 : 'C',
    4 : 'B',
    6 : 'S',
    7 : 'H',
    9 : 'H',
    10 : 'E',
    11 : 'L',
    14 : 'C',
    24 : 'S',
    26 : 'E',
    28 : 'L'
    }

pomdp.initialize(Start,Dest)
#pomdp.writefile()


#Added by David Chen (dlcc) to get a fresh map every time
def getMapGrid():
  mapGrid = POMDP.POMDP('Grid')

  mapGrid.grid = [
    '###########',
    '#.......###',
    '#.#.#.#.###',
    '#.......###',
    '#.#.#.#.###',
    '#.......#.#',
    '#.#.###.#.#',
    '#.........#',
    '#.#.#.#####',
    '#.....#####',
    '#.#.#.#####',
    '#.....#####',
    '#.#########',
    '#...#######',
    '#.#.#######',
    '#...#######',
    '###########',
    ]

  mapGrid.map_dir = 'Maps'
  mapGrid.map_image_file = 'MapDirection%s.png' % (mapGrid.name)
  mapGrid.map_offsets = (25,0,300,440)

  mapGrid.locations = {
    1 : ( 1,1),  9 : ( 1,3), 17 : ( 1,5), 23 : (1,7),
    2 : ( 3,1), 10 : ( 3,3), 18 : ( 3,5), 24 : (3,7),
    3 : ( 5,1), 11 : ( 5,3), 19 : ( 5,5), 25 : (5,7), 27 : (5,9),
    4 : ( 7,1), 12 : ( 7,3), 20 : ( 7,5), 26 : (7,7), 28 : (7,9),
    5 : ( 9,1), 13 : ( 9,3), 21 : ( 9,5),
    6 : (11,1), 14 : (11,3), 22 : (11,5),
    7 : (13,1), 15 : (13,3),
    8 : (15,1), 16 : (15,3),
    }

  mapGrid.plat_row_offset = 4
  mapGrid.plat_col_offset = -1
  mapGrid.plat_directions = {'N':0, 'E':90, 'S':180, 'W':270}
  mapGrid.plat_orientations = {0:0, 90:1, 180:2, 270:3}

  mapGrid.NumPlaces=29
  mapGrid.NumPoses=4

  mapGrid.Gateways = {
    (1,1) : (9,1),
    (1,2) : (2,2),
    (2,1) : (10,1),
    (2,2) : (3,2),
    (3,1) : (11,1),
    (3,2) : (4,2),
    (4,1) : (12,1),
    (4,2) : (5,2),
    (5,1) : (13,1),
    (5,2) : (6,2),
    (6,1) : (14,1),
    (6,2) : (7,2),
    (7,1) : (15,1),
    (7,2) : (8,2),
    (8,1) : (16,1),
    (9,1) : (17,1),
    (9,2) : (10,2),
    (10,1) : (18,1),
    (10,2) : (11,2),
    (11,1) : (19,1),
    (11,2) : (12,2),
    (12,1) : (20,1),
    (12,2) : (13,2),
    (13,1) : (21,1),
    (13,2) : (14,2),
    (14,1) : (22,1),
    (15,2) : (16,2),
    (17,1) : (23,1),
    (17,2) : (18,2),
    (18,1) : (24,1),
    (18,2) : (19,2),
    (19,1) : (25,1),
    (20,1) : (26,1),
    (20,2) : (21,2),
    (21,2) : (22,2),
    (23,2) : (24,2),
    (24,2) : (25,2),
    (25,2) : (26,2),
    (26,1) : (28,1),
    (27,2) : (28,2),
    }

  mapGrid.PositionSet = {}

  mapGrid.PositionSet[0] = {
    1 : 10,
    2 : 26,
    3 : 5,
    4 : 23,
    5 : 15,
    6 : 19,
    7 : 13,
    }

  mapGrid.PositionSet[1] = {
    1 : 28,
    2 : 7,
    3 : 10,
    4 : 14,
    5 : 3,
    6 : 13,
    7 : 20,
    }

  mapGrid.PosSet = 0
  mapGrid.Positions = mapGrid.PositionSet[mapGrid.PosSet]

  mapGrid.PathSpecs = {
    '1+' : [(1,1),(9,1),(17,1),(23,1)],
    '2+' : [(2,1),(10,1),(18,1),(24,1)],
    '3+' : [(3,1),(11,1),(19,1),(25,1)],
    '4+' : [(4,1),(12,1),(20,1),(26,1),(28,1)],
    '5+' : [(5,1),(13,1),(21,1),],
    '6+' : [(6,1),(14,1),(22,1),],
    '7+' : [(7,1),(15,1),],
    '8+' : [(8,1),(16,1),],
    'A+' : [(1,2),(2,2),(3,2),(4,2),(5,2),(6,2),(7,2),(8,2)],
    'B+' : [(9,2),(10,2),(11,2),(12,2),(13,2),(14,2),],
    'B1+' : [(15,2),(16,2)],
    'C+' : [(17,2),(18,2),(19,2)],
    'C1+' : [(20,2),(21,2),(22,2),],
    'D+' : [(23,2),(24,2),(25,2),(26,2)],
    'E+' : [(27,2),(28,2)],
    }

  mapGrid.TextureLocs = {
    (1,1) : 'g',
    (1,2) : 't',
    (2,1) : 'r',
    (2,2) : 't',
    (3,1) : 'w',
    (3,2) : 't',
    (4,1) : 's',
    (4,2) : 't',
    (5,1) : 'c',
    (5,2) : 't',
    (6,1) : 'c',
    (6,2) : 't',
    (7,1) : 'c',
    (7,2) : 't',
    (8,1) : 'c',
    (9,1) : 'g',
    (9,2) : 'b',
    (10,1) : 'r',
    (10,2) : 'b',
    (11,1) : 'w',
    (11,2) : 'b',
    (12,1) : 's',
    (12,2) : 'b',
    (13,1) : 'c',
    (13,2) : 'b',
    (14,1) : 'c',
    (15,2) : 'c',
    (17,1) : 'g',
    (17,2) : 'c',
    (18,1) : 'r',
    (18,2) : 'c',
    (19,1) : 'w',
    (20,1) : 's',
    (20,2) : 'c',
    (21,2) : 'c',
    (23,2) : 'h',
    (24,2) : 'h',
    (25,2) : 'h',
    (26,1) : 's',
    (27,2) : 'c',
    }

  mapGrid.PictureLocs = {
    (1,1) : '6',
    (1,2) : '6',
    (2,1) : '6',
    (2,2) : '6',
    (3,1) : '6',
    (3,2) : '8',
    (4,1) : '8',
    (4,2) : '8',
    (5,1) : '8',
    (5,2) : '8',
    (6,1) : '8',
    (6,2) : '8',
    (7,1) : '8',
    (7,2) : '8',
    (8,1) : '8',
    (9,1) : '6',
    (9,2) : '6',
    (10,1) : '6',
    (10,2) : '6',
    (11,1) : '7',
    (11,2) : '7',
    (12,1) : '7',
    (12,2) : '8',
    (13,1) : '7',
    (13,2) : '8',
    (14,1) : '8',
    (15,2) : '8',
    (17,1) : '6',
    (17,2) : '6',
    (18,1) : '6',
    (18,2) : '6',
    (19,1) : '7',
    (20,1) : '7',
    (20,2) : '7',
    (21,2) : '7',
    (23,2) : '6',
    (24,2) : '6',
    (25,2) : '7',
    (26,1) : '7',
    (27,2) : '7',
    }

  mapGrid.ObjectLocs = {
    3 : 'C',
    4 : 'B',
    6 : 'S',
    7 : 'H',
    9 : 'H',
    10 : 'E',
    11 : 'L',
    14 : 'C',
    24 : 'S',
    26 : 'E',
    28 : 'L'
    }

  #Dummy start and dest since the original MARCO code requires them
  Start,Dest = 4,5
  mapGrid.initialize(Start,Dest)
  return mapGrid