#!/usr/bin/env python
import MarkovLoc_Antie

pomdp = MarkovLoc_Antie.POMDP('MarkovLoc_Grid_4_5')

pomdp.NumPlaces=29
pomdp.NumPoses=4

pomdp.Gateways = {
    (1,1) : (9,1),
    (1,2) : (2,2),
    (2,1) : (10,1),
    (2,2) : (3,2),
    (3,1) : (11,1),
    (3,2) : (4,2),
    (4,1) : (12,1),
    (4,2) : (5,2),
    (5,1) : (13,1),
    (5,2) : (6,2),
    (6,1) : (14,1),
    (6,2) : (7,2),
    (7,1) : (15,1),
    (7,2) : (8,2),
    (8,1) : (16,1),
    (9,1) : (17,1),
    (9,2) : (10,2),
    (10,1) : (18,1),
    (10,2) : (11,2),
    (11,1) : (19,1),
    (11,2) : (12,2),
    (12,1) : (20,1),
    (12,2) : (13,2),
    (13,1) : (21,1),
    (13,2) : (14,2),
    (14,1) : (22,1),
    (15,2) : (16,2),
    (17,1) : (23,1),
    (17,2) : (18,2),
    (18,1) : (24,1),
    (18,2) : (19,2),
    (19,1) : (25,1),
    (20,1) : (26,1),
    (20,2) : (21,2),
    (21,2) : (22,2),
    (23,2) : (24,2),
    (24,2) : (25,2),
    (25,2) : (26,2),
    (26,1) : (28,1),
    (27,2) : (28,2),
    }

pomdp.Positions = {
    1 : 10,
    2 : 26,
    3 : 5,
    4 : 23,
    5 : 15,
    6 : 19,
    7 : 13,
    }

pomdp.PathSpecs = {
    '1+' : [(1,1),(9,1),(17,1),(23,1)],
    '2+' : [(2,1),(10,1),(18,1),(24,1)],
    '3+' : [(3,1),(11,1),(19,1),(25,1)],
    '4+' : [(4,1),(12,1),(20,1),(26,1),(28,1)],
    '5+' : [(5,1),(13,1),(21,1),],
    '6+' : [(6,1),(14,1),(22,1),],
    '7+' : [(7,1),(15,1),],
    '8+' : [(8,1),(16,1),],
    'A+' : [(1,2),(2,2),(3,2),(4,2),(5,2),(6,2),(7,2),(8,2)],
    'B+' : [(9,2),(10,2),(11,2),(12,2),(13,2),(14,2),],
    'B1+' : [(15,2),(16,2)],
    'C+' : [(17,2),(18,2),(19,2)],
    'C1+' : [(20,2),(21,2),(22,2),],
    'D+' : [(23,2),(24,2),(25,2),(26,2)],
    'E+' : [(27,2),(28,2)],
    }

pomdp.TextureLocs = {
    (1,1) : 'g',
    (1,2) : 't',
    (2,1) : 'r',
    (2,2) : 't',
    (3,1) : 'w',
    (3,2) : 't',
    (4,1) : 's',
    (4,2) : 't',
    (5,1) : 'c',
    (5,2) : 't',
    (6,1) : 'c',
    (6,2) : 't',
    (7,1) : 'c',
    (7,2) : 't',
    (8,1) : 'c',
    (9,1) : 'g',
    (9,2) : 'b',
    (10,1) : 'r',
    (10,2) : 'b',
    (11,1) : 'w',
    (11,2) : 'b',
    (12,1) : 's',
    (12,2) : 'b',
    (13,1) : 'c',
    (13,2) : 'b',
    (14,1) : 'c',
    (15,2) : 'c',
    (17,1) : 'g',
    (17,2) : 'c',
    (18,1) : 'r',
    (18,2) : 'c',
    (19,1) : 'w',
    (20,1) : 's',
    (20,2) : 'c',
    (21,2) : 'c',
    (23,2) : 'h',
    (24,2) : 'h',
    (25,2) : 'h',
    (26,1) : 's',
    (27,2) : 'c',
    }

pomdp.PictureLocs = {
    (1,1) : '6',
    (1,2) : '6',
    (2,1) : '6',
    (2,2) : '6',
    (3,1) : '6',
    (3,2) : '8',
    (4,1) : '8',
    (4,2) : '8',
    (5,1) : '8',
    (5,2) : '8',
    (6,1) : '8',
    (6,2) : '8',
    (7,1) : '8',
    (7,2) : '8',
    (8,1) : '8',
    (9,1) : '6',
    (9,2) : '6',
    (10,1) : '6',
    (10,2) : '6',
    (11,1) : '7',
    (11,2) : '7',
    (12,1) : '7',
    (12,2) : '8',
    (13,1) : '7',
    (13,2) : '8',
    (14,1) : '8',
    (15,2) : '8',
    (17,1) : '6',
    (17,2) : '6',
    (18,1) : '6',
    (18,2) : '6',
    (19,1) : '7',
    (20,1) : '7',
    (20,2) : '7',
    (21,2) : '7',
    (23,2) : '6',
    (24,2) : '6',
    (25,2) : '7',
    (26,1) : '7',
    (27,2) : '7',
    }

pomdp.ObjectLocs = {
    3 : 'C',
    4 : 'B',
    6 : 'S',
    7 : 'H',
    9 : 'H',
    10 : 'E',
    11 : 'L',
    14 : 'C',
    26 : 'E',
    28 : 'L'
    }

pomdp.initialize(Dest)
pomdp.writefile()
