#!/usr/bin/env python
import sys
import MarkovLoc_Antie_Periph as POMDP

#Commented out by David Chen
#if len(sys.argv)>1 and sys.argv[1]:
#    Start,Dest = sys.argv[:2]
#else:
Start,Dest = 4,5

pomdp = POMDP.POMDP('Jelly')

pomdp.grid = [
    '###############',
    '#...###########',
    '#.#.###########',
    '#.#...#########',
    '#.###.#########',
    '#.###.#########',
    '#.###.#########',
    '#.#.....#######',
    '#.#.#.#.#######',
    '#...#.#.......#',
    '#.#.###.#.#####',
    '#.#...#.#.#####',
    '###.#.#.#######',
    '###.#.....#####',
    '#####.#.#.#####',
    '#####.#...#####',
    '#####.#.#######',
    '#####.......###',
    '#######.#.#####',
    '#######.#...###',
    '#########.#####',
    '#########.#####',
    '###############',
    ]

pomdp.map_dir = 'Maps'
pomdp.map_image_file = 'MapDirection%s.png' % (pomdp.name)
pomdp.map_offsets = (40,0,380,500)

pomdp.locations = {
    1 : ( 1,1),  7 : ( 1,3),
    2 : ( 3,1),  8 : ( 3,3), 13 : ( 3,5),
    3 : ( 5,1),              14 : ( 5,5),
    4 : ( 7,1),  9 : ( 7,3), 15 : ( 7,5), 21 : ( 7,7),
    5 : ( 9,1), 10 : ( 9,3), 16 : ( 9,5), 22 : ( 9,7), 28 : ( 9,9), 34 : ( 9,11), 37 : ( 9,13),
    6 : (11,1), 11 : (11,3), 17 : (11,5), 23 : (11,7), 29 : (11,9),
                12 : (13,3), 18 : (13,5), 24 : (13,7), 30 : (13,9),
                             19 : (15,5), 25 : (15,7), 31 : (15,9),
                             20 : (17,5), 26 : (17,7), 32 : (17,9), 35 : (17,11),
                                          27 : (19,7), 33 : (19,9), 36 : (19,11),
}

pomdp.plat_row_offset = 14
pomdp.plat_col_offset = 13
pomdp.plat_directions = {'N':90, 'E':180, 'S':270, 'W':0}
pomdp.plat_orientations = {90:0, 180:1, 270:2, 0:3}

pomdp.plat_swap_axes = True
pomdp.plat_mid_col = 18.5

pomdp.NumPlaces=38
pomdp.NumPoses=4

pomdp.Gateways = {
    (1,1) : (7,1),
    (1,2) : (2,2),
    (2,2) : (3,2),
    (3,2) : (4,2),
    (4,2) : (5,2),
    (5,1) : (10,1),
    (5,2) : (6,2),
    (7,2) : (8,2),
    (8,1) : (13,1),
    (9,1) : (15,1),
    (9,2) : (10,2),
    (10,2) : (11,2),
    (11,1) : (17,1),
    (11,2) : (12,2),
    (13,2) : (14,2),
    (14,2) : (15,2),
    (15,1) : (21,1),
    (15,2) : (16,2),
    (17,2) : (18,2),
    (18,1) : (24,1),
    (18,2) : (19,2),
    (19,2) : (20,2),
    (20,1) : (26,1),
    (21,2) : (22,2),
    (22,1) : (28,1),
    (22,2) : (23,2),
    (23,2) : (24,2),
    (24,1) : (30,1),
    (24,2) : (25,2),
    (25,1) : (31,1),
    (25,2) : (26,2),
    (26,1) : (32,1),
    (26,2) : (27,2),
    (28,1) : (34,1),
    (28,2) : (29,2),
    (30,2) : (31,2),
    (32,1) : (35,1),
    (32,2) : (33,2),
    (33,1) : (36,1),
    (34,1) : (37,1),
    }

pomdp.PositionSet = {}

pomdp.PositionSet[0] = {
    1 : 10,
    2 : 7,
    3 : 25,
    4 : 35,
    5 : 14,
    6 : 29,
    7 : 18,
    }

pomdp.PositionSet[1] = {
    1 : 26,
    2 : 11,
    3 : 14,
    4 : 22,
    5 : 31,
    6 : 33,
    7 : 2,
    }

pomdp.PosSet = 0
pomdp.Positions = pomdp.PositionSet[pomdp.PosSet]

pomdp.PathSpecs = {
    '1+' : [(1,1),(7,1)],
    '2+' : [(8,1),(13,1)],
    '4+' : [(9,1),(15,1),(21,1)],
    '5+' : [(5,1),(10,1)],
    '5A+' : [(22,1),(28,1),(34,1),(37,1)],
    '6+' : [(11,1),(17,1)],
    '7+' : [(18,1),(24,1),(30,1)],
    '8+' : [(25,1),(31,1)],
    '9+' : [(20,1),(26,1),(32,1),(35,1)],
    '10+' : [(33,1),(36,1)],
    'A+' : [(1,2),(2,2),(3,2),(4,2,),(5,2),(6,2)],
    'B+' : [(7,2),(8,2)],
    'B1+' : [(9,2),(10,2),(11,2),(12,2)],
    'C+' :  [(13,2),(14,2),(15,2),(16,2)],
    'C1+' : [(17,2),(18,2),(19,2),(20,2)],
    'D+' : [(21,2),(22,2),(23,2),(24,2),(25,2),(26,2),(27,2)],
    'E+' : [(28,2),(29,2)],
    'E1+' : [(30,2),(31,2)],
    'E2+' : [(32,2),(33,2)],
    }

pomdp.TextureLocs = {
    (1,1) : 'c',
    (1,2) : 'g',
    (2,2) : 'g',
    (3,2) : 'g',
    (4,2) : 'g',
    (5,1) : 'c',
    (5,2) : 'g',
    (7,2) : 'c',
    (8,1) : 'c',
    (9,2) : 'b',
    (10,2) : 'b',
    (11,2) : 'b',
    (9,1) : 'c',
    (15,1) : 'c',
    (11,1) : 'c',
    (13,2) : 'w',
    (14,2) : 'w',
    (15,2) : 'w',
    (17,2) : 's',
    (18,2) : 's',
    (19,2) : 's',
    (18,1) : 'c',
    (24,1) : 'c',
    (20,1) : 'h',
    (26,1) : 'h',
    (32,1) : 'h',
    (21,2) : 't',
    (22,2) : 't',
    (23,2) : 't',
    (24,2) : 't',
    (25,2) : 't',
    (26,2) : 't',
    (22,1) : 'r',
    (28,1) : 'r',
    (34,1) : 'r',
    (28,2) : 'c',
    (25,1) : 'c',
    (30,2) : 'c',
    (32,2) : 'c',
    (33,1) : 'c',
    }

pomdp.PictureLocs = {
    (1,1) : '8',
    (1,2) : '8',
    (2,2) : '8',
    (3,2) : '8',
    (4,2) : '8',
    (5,1) : '8',
    (5,2) : '8',
    (7,2) : '8',
    (8,1) : '8',
    (9,2) : '8',
    (10,2) : '7',
    (11,2) : '7',
    (9,1) : '8',
    (15,1) : '7',
    (11,1) : '7',
    (13,2) : '8',
    (14,2) : '8',
    (15,2) : '7',
    (17,2) : '7',
    (18,2) : '6',
    (19,2) : '6',
    (18,1) : '7',
    (24,1) : '6',
    (20,1) : '6',
    (26,1) : '6',
    (32,1) : '6',
    (21,2) : '7',
    (22,2) : '7',
    (23,2) : '7',
    (24,2) : '6',
    (25,2) : '6',
    (26,2) : '6',
    (22,1) : '7',
    (28,1) : '7',
    (34,1) : '7',
    (28,2) : '7',
    (25,1) : '6',
    (30,2) : '6',
    (32,2) : '6',
    (33,1) : '6',
    }

pomdp.ObjectLocs = {
    1 : 'H',
    5 : 'C',
    8 : 'L',
    11 : 'S',
    15 : 'E',
    17 : 'S',
    18 : 'B',
    24 : 'C',
    26 : 'H',
    33 : 'L',
    34 : 'E',
    }

pomdp.initialize(Start,Dest)
#pomdp.writefile()

#Added by David Chen (dlcc) for getting a fresh copy of the map
def getMapJelly():
  mapJelly = POMDP.POMDP('Jelly')

  mapJelly.grid = [
    '###############',
    '#...###########',
    '#.#.###########',
    '#.#...#########',
    '#.###.#########',
    '#.###.#########',
    '#.###.#########',
    '#.#.....#######',
    '#.#.#.#.#######',
    '#...#.#.......#',
    '#.#.###.#.#####',
    '#.#...#.#.#####',
    '###.#.#.#######',
    '###.#.....#####',
    '#####.#.#.#####',
    '#####.#...#####',
    '#####.#.#######',
    '#####.......###',
    '#######.#.#####',
    '#######.#...###',
    '#########.#####',
    '#########.#####',
    '###############',
    ]

  mapJelly.map_dir = 'Maps'
  mapJelly.map_image_file = 'MapDirection%s.png' % (mapJelly.name)
  mapJelly.map_offsets = (40,0,380,500)

  mapJelly.locations = {
    1 : ( 1,1),  7 : ( 1,3),
    2 : ( 3,1),  8 : ( 3,3), 13 : ( 3,5),
    3 : ( 5,1),              14 : ( 5,5),
    4 : ( 7,1),  9 : ( 7,3), 15 : ( 7,5), 21 : ( 7,7),
    5 : ( 9,1), 10 : ( 9,3), 16 : ( 9,5), 22 : ( 9,7), 28 : ( 9,9), 34 : ( 9,11), 37 : ( 9,13),
    6 : (11,1), 11 : (11,3), 17 : (11,5), 23 : (11,7), 29 : (11,9),
                12 : (13,3), 18 : (13,5), 24 : (13,7), 30 : (13,9),
                             19 : (15,5), 25 : (15,7), 31 : (15,9),
                             20 : (17,5), 26 : (17,7), 32 : (17,9), 35 : (17,11),
                                          27 : (19,7), 33 : (19,9), 36 : (19,11),
}

  mapJelly.plat_row_offset = 14
  mapJelly.plat_col_offset = 13
  mapJelly.plat_directions = {'N':90, 'E':180, 'S':270, 'W':0}
  mapJelly.plat_orientations = {90:0, 180:1, 270:2, 0:3}

  mapJelly.plat_swap_axes = True
  mapJelly.plat_mid_col = 18.5

  mapJelly.NumPlaces=38
  mapJelly.NumPoses=4

  mapJelly.Gateways = {
    (1,1) : (7,1),
    (1,2) : (2,2),
    (2,2) : (3,2),
    (3,2) : (4,2),
    (4,2) : (5,2),
    (5,1) : (10,1),
    (5,2) : (6,2),
    (7,2) : (8,2),
    (8,1) : (13,1),
    (9,1) : (15,1),
    (9,2) : (10,2),
    (10,2) : (11,2),
    (11,1) : (17,1),
    (11,2) : (12,2),
    (13,2) : (14,2),
    (14,2) : (15,2),
    (15,1) : (21,1),
    (15,2) : (16,2),
    (17,2) : (18,2),
    (18,1) : (24,1),
    (18,2) : (19,2),
    (19,2) : (20,2),
    (20,1) : (26,1),
    (21,2) : (22,2),
    (22,1) : (28,1),
    (22,2) : (23,2),
    (23,2) : (24,2),
    (24,1) : (30,1),
    (24,2) : (25,2),
    (25,1) : (31,1),
    (25,2) : (26,2),
    (26,1) : (32,1),
    (26,2) : (27,2),
    (28,1) : (34,1),
    (28,2) : (29,2),
    (30,2) : (31,2),
    (32,1) : (35,1),
    (32,2) : (33,2),
    (33,1) : (36,1),
    (34,1) : (37,1),
    }

  mapJelly.PositionSet = {}

  mapJelly.PositionSet[0] = {
    1 : 10,
    2 : 7,
    3 : 25,
    4 : 35,
    5 : 14,
    6 : 29,
    7 : 18,
    }

  mapJelly.PositionSet[1] = {
    1 : 26,
    2 : 11,
    3 : 14,
    4 : 22,
    5 : 31,
    6 : 33,
    7 : 2,
    }

  mapJelly.PosSet = 0
  mapJelly.Positions = mapJelly.PositionSet[mapJelly.PosSet]

  mapJelly.PathSpecs = {
    '1+' : [(1,1),(7,1)],
    '2+' : [(8,1),(13,1)],
    '4+' : [(9,1),(15,1),(21,1)],
    '5+' : [(5,1),(10,1)],
    '5A+' : [(22,1),(28,1),(34,1),(37,1)],
    '6+' : [(11,1),(17,1)],
    '7+' : [(18,1),(24,1),(30,1)],
    '8+' : [(25,1),(31,1)],
    '9+' : [(20,1),(26,1),(32,1),(35,1)],
    '10+' : [(33,1),(36,1)],
    'A+' : [(1,2),(2,2),(3,2),(4,2,),(5,2),(6,2)],
    'B+' : [(7,2),(8,2)],
    'B1+' : [(9,2),(10,2),(11,2),(12,2)],
    'C+' :  [(13,2),(14,2),(15,2),(16,2)],
    'C1+' : [(17,2),(18,2),(19,2),(20,2)],
    'D+' : [(21,2),(22,2),(23,2),(24,2),(25,2),(26,2),(27,2)],
    'E+' : [(28,2),(29,2)],
    'E1+' : [(30,2),(31,2)],
    'E2+' : [(32,2),(33,2)],
    }

  mapJelly.TextureLocs = {
    (1,1) : 'c',
    (1,2) : 'g',
    (2,2) : 'g',
    (3,2) : 'g',
    (4,2) : 'g',
    (5,1) : 'c',
    (5,2) : 'g',
    (7,2) : 'c',
    (8,1) : 'c',
    (9,2) : 'b',
    (10,2) : 'b',
    (11,2) : 'b',
    (9,1) : 'c',
    (15,1) : 'c',
    (11,1) : 'c',
    (13,2) : 'w',
    (14,2) : 'w',
    (15,2) : 'w',
    (17,2) : 's',
    (18,2) : 's',
    (19,2) : 's',
    (18,1) : 'c',
    (24,1) : 'c',
    (20,1) : 'h',
    (26,1) : 'h',
    (32,1) : 'h',
    (21,2) : 't',
    (22,2) : 't',
    (23,2) : 't',
    (24,2) : 't',
    (25,2) : 't',
    (26,2) : 't',
    (22,1) : 'r',
    (28,1) : 'r',
    (34,1) : 'r',
    (28,2) : 'c',
    (25,1) : 'c',
    (30,2) : 'c',
    (32,2) : 'c',
    (33,1) : 'c',
    }

  mapJelly.PictureLocs = {
    (1,1) : '8',
    (1,2) : '8',
    (2,2) : '8',
    (3,2) : '8',
    (4,2) : '8',
    (5,1) : '8',
    (5,2) : '8',
    (7,2) : '8',
    (8,1) : '8',
    (9,2) : '8',
    (10,2) : '7',
    (11,2) : '7',
    (9,1) : '8',
    (15,1) : '7',
    (11,1) : '7',
    (13,2) : '8',
    (14,2) : '8',
    (15,2) : '7',
    (17,2) : '7',
    (18,2) : '6',
    (19,2) : '6',
    (18,1) : '7',
    (24,1) : '6',
    (20,1) : '6',
    (26,1) : '6',
    (32,1) : '6',
    (21,2) : '7',
    (22,2) : '7',
    (23,2) : '7',
    (24,2) : '6',
    (25,2) : '6',
    (26,2) : '6',
    (22,1) : '7',
    (28,1) : '7',
    (34,1) : '7',
    (28,2) : '7',
    (25,1) : '6',
    (30,2) : '6',
    (32,2) : '6',
    (33,1) : '6',
    }

  mapJelly.ObjectLocs = {
    1 : 'H',
    5 : 'C',
    8 : 'L',
    11 : 'S',
    15 : 'E',
    17 : 'S',
    18 : 'B',
    24 : 'C',
    26 : 'H',
    33 : 'L',
    34 : 'E',
    }

  #Dummy start and dest since it's required by the original MARCO code
  Start,Dest = 4,5
  mapJelly.initialize(Start,Dest)
  return mapJelly